#!/usr/bin/python

import os, string

_valid_characters = string.lowercase + string.digits + '$.-_/';

def _is_valid(c):
  global _valid_characters

  if c in _valid_characters:
    return c
  else:
    return '$'

def mangle(fn):
  fn = string.lower(fn)

  # Remove invalid characters
  fn = string.joinfields(map(_is_valid, tuple(fn)), '')

  # Remove all periods but one
  parts = string.splitfields(fn, '.')

  if len(parts) > 2:
    fn = string.joinfields(parts[:-1], '_') + '.' + parts[-1]
  elif len(parts) == 1:
    fn = fn

  return fn

def show(f, trans):
  for t in trans:
    f.write('mv      %-36s %s\n' % t)
  
def Recurse(tovms, fromvms, path):
  print path

  files = os.listdir(path)
  path = path + os.sep

  for fn in files:
    newfn = mangle(fn)
    if fn != newfn: 
      fromvms.append(path + newfn, path + fn)
    if os.path.isdir(path + fn):
      Recurse(tovms, fromvms, path + fn)
    if fn != newfn: 
      tovms.append(path + fn, path + newfn)

def Main():
  tovms = []
  fromvms = []
  Recurse(tovms, fromvms, os.curdir)

  show(open("vms_mangle.sh", "wa"), tovms)
  show(open("vms_demangle.sh", "wa"), fromvms)

Main()
